require 'fileutils'
require 'open3'

def process_directory(dir)
  procs = []
  dirs = dir.entries
  dirs.delete_if { |entry| entry =~ /^\./ }
  dirs.delete_if { |entry| entry =~ /\.rb$/ }
  dirs.each { |entry| 
    full_path = File.join(dir.path, entry)
    if File.directory?(full_path)
      FileUtils.cd(full_path) {
        stdin, stdout, stderr = Open3.popen3("ruby ../single.rb")
        procs << stdout
      }
    end
  }
  count = 0
  procs.each { |stdout|
    value = stdout.gets.chomp
    puts "Received value from sub-process: #{value}"
    count += value.to_i
  }
  puts "#{count}"
end

current_dir = `pwd`.chomp
process_directory(Dir.new(current_dir))
