class DirSearch

  attr_reader   :dir, :term
  attr_accessor :count

  def initialize(dir, term)
    @count = 0
    @dir   = dir
    @term  = term
  end

  def process_file(name)
    File.open(name) do |f|
      lines = f.readlines
      lines = lines.find_all { |line| line.include?(@term) }
      if lines.size > 0
        @count += 1
      end
    end
  end

  def process_directory(dir)
    dirs = dir.entries
    dirs.delete_if { |entry| entry =~ /^\./ }
    dirs.delete_if { |entry| entry =~ /\.rb$/ }
    dirs.each { |entry| 
      full_path = File.join(dir.path, entry)
      if File.directory?(full_path)
        process_directory(Dir.new(full_path))
      else
        process_file(full_path)
      end
    }
  end

  def search
    process_directory(Dir.new(@dir))
  end

end

current_dir = `pwd`.chomp
search = DirSearch.new(current_dir, "iran")
search.search

puts "#{search.count}"
